// ###############################################################################
// ### Re-Generated, By Darthmule (http://steamcommunity.com/id/notdarthmule/) ###
// ###############################################################################


// #######################
// ## CRUNCHING NUMBERS ##
// #######################

/* test version leftovers
global.genStartHP = 1250;       // Static value for the Generator's maximum health
global.genIncrementHP = 150;    // Linear value for the Generator's maximum health that increases based on the amount of players
global.genMaxSHD = 100;         // Static value for the Generator's maximum shield
global.genIncrementMaxSHD = 25; // Linear value for the Generator's maximum shield (if set to a value higher than zero)
global.genHealThreshold = 0.5;  // How large or small the threshold is that it can heal to (defaults to max health * 0.5).
global.genHealRate = 0.166;     // The multiplier which the generator heals, I advice to keep this between 0.09 or 0.25
global.genSHDHealRate = 1.5;    // The multiplier which the generator heals, I advice to keep this between 0.09 or 0.25
*/

ini_open("gg2.ini");
global.genStartHP =         max(1, min(4096, ini_read_real("Re-Generated Plugin", "Generator Health Calculation (Static)", 1250)));
global.genIncrementHP =     max(1, min(512, ini_read_real("Re-Generated Plugin", "Generator Health Calculation (Linear)", 150)));
global.genMaxSHD =          max(1, min(1024, ini_read_real("Re-Generated Plugin", "Generator Shield Calculation (Static)", 150)));
global.genIncrementMaxSHD = max(0, min(512, ini_read_real("Re-Generated Plugin", "Generator Shield Calculation (Linear)", 25)));
global.genHealThreshold =   max(0.01, min(1, ini_read_real("Re-Generated Plugin", "Generator Health Regeneration (Threshold, Max health * <this value>))", 0.5)));
global.genHealRate =        max(0.01, min(1, ini_read_real("Re-Generated Plugin", "Generator Health Regeneration (Healing Rate)", 0.166)));
global.genSHDHealRate =     max(0.01, min(1, ini_read_real("Re-Generated Plugin", "Generator Shield Regeneration (Recovery Rate)", 1.5)));
ini_close();


// ####################
// ## THE REAL MAGIC ##
// ####################
object_event_clear(Generator, ev_create, 0)       // Delete the 'Generator' object's create event
object_event_add(Generator, ev_create, 0, "       // Re-add the same thing we just deleted but with the plugin's changes 

  playercount = instance_number( Player )+1;
  
  if (global.genIncrementMaxSHD > 0)
  {
    maxShieldHp = global.genMaxSHD + playercount * global.genIncrementMaxSHD;
  }
  else
  {
    maxShieldHp = global.genMaxSHD;
  }

  maxHp = global.genStartHP + playercount * global.genIncrementHP;

  hp = maxHp;
  shieldHp = maxShieldHp;

  maxShieldResistance = 0.75;
  minShieldResistance = 0.25;

  shieldResistance = maxShieldResistance;
  isShieldRegenerating = false;
  isGeneratorHealing = false;
  regenerationBuffer = 3 * 30;
  smokeCount = 0;
  image_speed = 0.3 * global.delta_factor;
  blastRadius = 400;
  shieldIndex = 0;
  soundPlayed = false;
");

object_event_clear(Generator, ev_step, ev_step_normal)       // Delete the 'Generator' object's step event
object_event_add(Generator, ev_step, ev_step_normal, "       // Re-add the same thing we just deleted but with the plugin's changes 

  if (shieldHp > 0)
  {
      shieldIndex += 4/30 * global.delta_factor;
      if shieldIndex > 4 shieldIndex = 0;
  }

  if (isShieldRegenerating)
  {
    shieldHp = min(shieldHp + isShieldRegenerating * global.genSHDHealRate * global.delta_factor, maxShieldHp);  
    if (shieldHp == maxShieldHp)
    {
        isGeneratorHealing = true; // for the green colour
    }
  }

  if (isGeneratorHealing)
  {
    hp = min(hp + isShieldRegenerating * global.genHealRate * global.delta_factor, maxHp / global.genHealThreshold, maxHp);
    
    if (hp > maxHp * global.genHealThreshold or hp > maxHp) // like I said, do not try to set it above 1.
    {
      isGeneratorHealing = false;
      isShieldRegenerating = false;
      playsound(x,y, CPDefendedSnd);
    }
    else
    {
      if (!soundPlayed)
      {
        playsound(x,y, CPBeginCapSnd);
        soundPlayed = true;
      }
    }
  }

  if (!isShieldRegenerating and isGeneratorHealing) // will be called when a projectile hits the thing
  {
    isGeneratorHealing = false; // for the green colour
    soundPlayed = false;
    playsound(x,y, CPDefendedSnd);
  }

  shieldResistance = minShieldResistance * (shieldHp > 0) + (maxShieldResistance - minShieldResistance) * (shieldHp/maxShieldHp);

");

object_event_clear(Generator, ev_draw, 0)       // Delete the 'Generator' object's draw event
object_event_add(Generator, ev_draw, 0, "       // Re-add the same thing we just deleted but the plugin's changes 

  xviewoffset = view_xview[0];
  yviewoffset = view_yview[0];
  xviewsize = view_wview[0];
  yviewsize = view_hview[0];
      
  if distance_to_point(xviewoffset+xviewsize/2,yviewoffset+yviewsize/2) > 800 exit;
  draw_sprite_ext(sprite_index, image_index, x, y, 1, 1, 0, c_white, 1);

  if (isGeneratorHealing)
  {
    draw_sprite_ext(GeneratorShieldS, floor(shieldIndex), x, y, 1, 1, 0, make_color_rgb(240, 205, 34), 2);
  }
  else
  {
    draw_sprite_ext(GeneratorShieldS, floor(shieldIndex), x, y, 1, 1, 0, c_white, shieldResistance);
  }

");

object_event_clear(GeneratorHUD, ev_draw, 0)       // Delete the 'Generator HUD' object's draw event
object_event_add(GeneratorHUD, ev_draw, 0, "       // Re-add the same thing we just deleted but with the plugin's changes 

  xoffset = view_xview[0];
  yoffset = view_yview[0];
  xsize = view_wview[0];
  ysize = view_hview[0];
  xshift = -320*global.timerPos;
  yshift = 5*global.timerPos;

  barcolor = make_color_rgb(217,217,183);
  barcolorhealing = c_green;

  draw_set_alpha(1);

  draw_sprite_ext(GeneratorHUDS,0,xoffset+xsize/2,yoffset+ysize-50,2,2,0,c_white,1);
  if instance_exists(GeneratorRed) {
      draw_sprite_ext(GeneratorRedS,GeneratorRed.image_index,xoffset+xsize/2-50,yoffset+ysize-50,1,1,0,c_white,1);
      
      if (GeneratorRed.isGeneratorHealing)
      {
        draw_sprite_ext(GeneratorShieldS, floor(GeneratorRed.shieldIndex), xoffset+xsize/2-50, yoffset+ysize-50, 1, 1, 0, make_color_rgb(240, 205, 34), GeneratorRed.shieldResistance);
        draw_healthbar(xoffset+xsize/2-77, yoffset+ysize-75, xoffset+xsize/2-25, yoffset+ysize-68,GeneratorRed.hp*100/GeneratorRed.maxHp,c_black,barcolorhealing,barcolorhealing,0,true,true);
      }
      else
      {
        draw_sprite_ext(GeneratorShieldS, floor(GeneratorRed.shieldIndex), xoffset+xsize/2-50, yoffset+ysize-50, 1, 1, 0, c_white, GeneratorRed.shieldResistance);
        draw_healthbar(xoffset+xsize/2-77, yoffset+ysize-75, xoffset+xsize/2-25, yoffset+ysize-68,GeneratorRed.hp*100/GeneratorRed.maxHp,c_black,barcolor,barcolor,0,true,true);
      }

      draw_healthbar(xoffset+xsize/2-77, yoffset+ysize-30, xoffset+xsize/2-25, yoffset+ysize-23,GeneratorRed.shieldHp*100/GeneratorRed.maxShieldHp,c_black,barcolor,barcolor,0,true,true);
  }
  if instance_exists(GeneratorBlue) {
      draw_sprite_ext(GeneratorBlueS,GeneratorBlue.image_index,xoffset+xsize/2+50,yoffset+ysize-50,1,1,0,c_white,1);
      //draw_sprite_ext(GeneratorShieldS,floor(GeneratorBlue.shieldIndex),xoffset+xsize/2+50,yoffset+ysize-50,1,1,0,c_white, GeneratorBlue.shieldResistance);
      
      if (GeneratorBlue.isGeneratorHealing)
      {
        draw_sprite_ext(GeneratorShieldS, floor(GeneratorBlue.shieldIndex), xoffset+xsize/2+50, yoffset+ysize-50, 1, 1, 0, make_color_rgb(240, 205, 34), GeneratorBlue.shieldResistance);
        draw_healthbar(xoffset+xsize/2+23, yoffset+ysize-75, xoffset+xsize/2+75, yoffset+ysize-68,GeneratorBlue.hp*100/GeneratorBlue.maxHp,c_black,barcolorhealing,barcolorhealing,0,true,true);

      }
      else
      {
        draw_sprite_ext(GeneratorShieldS, floor(GeneratorBlue.shieldIndex), xoffset+xsize/2+50, yoffset+ysize-50, 1, 1, 0, c_white, GeneratorBlue.shieldResistance);
        draw_healthbar(xoffset+xsize/2+23, yoffset+ysize-75, xoffset+xsize/2+75, yoffset+ysize-68,GeneratorBlue.hp*100/GeneratorBlue.maxHp,c_black,barcolor,barcolor,0,true,true);
      }
      
      draw_healthbar(xoffset+xsize/2+23, yoffset+ysize-30, xoffset+xsize/2+75, yoffset+ysize-23,GeneratorBlue.shieldHp*100/GeneratorBlue.maxShieldHp,c_black,barcolor,barcolor,0,true,true);
  }

  draw_roundtimer(xoffset, yoffset, xsize, ysize, timer);

");


object_event_clear(Generator, ev_other, ev_user12)       // Delete the 'Generator' object's user12 event
object_event_add(Generator, ev_other, ev_user12, "       // Re-add the same thing we just deleted but with the plugin's changes 
  
  write_ushort(global.serializeBuffer, ceil(hp));
  write_ushort(global.serializeBuffer, ceil(shieldHp));
  
  /*
  write_ushort(global.serializeBuffer, ceil(maxHp));
  write_ushort(global.serializeBuffer, ceil(maxShieldHp));
  */

");

object_event_clear(Generator, ev_other, ev_user13)       // Delete the 'Generator' object's user12 event
object_event_add(Generator, ev_other, ev_user13, "       // Re-add the same thing we just deleted but with the plugin's changes 
  receiveCompleteMessage(global.serverSocket, 4, global.deserializeBuffer);
  
  hp = read_ushort(global.deserializeBuffer);
  shieldHp = read_ushort(global.deserializeBuffer);
  
  /*
  maxHp = read_ushort(global.deserializeBuffer);
  maxShieldHp = read_ushort(global.deserializeBuffer);
  */

");



